From 7c132949765f777e2e8d71336ef6e14f2bdd8b31 Mon Sep 17 00:00:00 2001
From: Sergey Fedorov <barracuda@macos-powerpc.org>
Date: Wed, 8 Jul 2026 21:31:24 +0800
Subject: [PATCH 2/5] vpx_dsp update

---
 vpx_dsp/ppc/vpx_convolve_altivec.c |   79 +
 vpx_dsp/ppc/vpx_idct_altivec.c     | 4066 ++++++++++++++++++++++++++++
 vpx_dsp/vpx_dsp.mk                 |    2 +
 vpx_dsp/vpx_dsp_rtcd_defs.pl       |   24 +-
 4 files changed, 4159 insertions(+), 12 deletions(-)
 create mode 100644 vpx_dsp/ppc/vpx_convolve_altivec.c
 create mode 100644 vpx_dsp/ppc/vpx_idct_altivec.c

diff --git a/vpx_dsp/ppc/vpx_convolve_altivec.c b/vpx_dsp/ppc/vpx_convolve_altivec.c
new file mode 100644
index 000000000..736118573
--- /dev/null
+++ b/vpx_dsp/ppc/vpx_convolve_altivec.c
@@ -0,0 +1,82 @@
+/*
+ *  Copyright (c) 2016 Cameron Kaiser and Contributors to TenFourFox
+ *  Copyright (c) 2025 Contributors to libvpx PowerPC port. All Rights Reserved.
+ *
+ *  Use of this source code is governed by a BSD-style license
+ *  that can be found in the LICENSE file in the root of the source
+ *  tree. An additional intellectual property rights grant can be found
+ *  in the file PATENTS.  All contributing project authors may
+ *  be found in the AUTHORS file in the root of the source tree.
+ */
+
+#include <altivec.h>
+
+#include "./vpx_dsp_rtcd.h"
+#include "vpx_ports/mem.h"
+
+#define _unaligned_load128(v, s)                                       \
+  {                                                                    \
+    const unsigned char *_s = (const unsigned char *)(s);              \
+    v = vec_perm(vec_ld(0, _s), vec_ld(16, _s), vec_lvsl(0, _s));      \
+  }
+
+void vpx_convolve_copy_altivec(const uint8_t *src, ptrdiff_t src_stride,
+                                uint8_t *dst, ptrdiff_t dst_stride,
+                                const InterpKernel *filter, int x0_q4,
+                                int x_step_q4, int y0_q4, int y_step_q4, int w,
+                                int h) {
+  int r;
+  vector unsigned char m0, m1, m2, m3;
+
+  (void)filter;
+  (void)x0_q4;
+  (void)x_step_q4;
+  (void)y0_q4;
+  (void)y_step_q4;
+
+  if (w == 4) {
+    for (r = h; r > 0; --r) {
+      *(uint32_t *)dst = *(const uint32_t *)src;
+      src += src_stride;
+      dst += dst_stride;
+    }
+  } else if (w == 8) {
+    for (r = h; r > 0; --r) {
+      *(uint64_t *)dst = *(const uint64_t *)src;
+      src += src_stride;
+      dst += dst_stride;
+    }
+  } else if (w == 16) {
+    for (r = h; r > 0; --r) {
+      _unaligned_load128(m0, src);
+      vec_st(m0, 0, dst);
+
+      src += src_stride;
+      dst += dst_stride;
+    }
+  } else if (w == 32) {
+    for (r = h; r > 0; --r) {
+      _unaligned_load128(m0, src);
+      _unaligned_load128(m1, src + 16);
+      vec_st(m0, 0, dst);
+      vec_st(m1, 16, dst);
+
+      src += src_stride;
+      dst += dst_stride;
+    }
+  } else {
+    for (r = h; r > 0; --r) {
+      _unaligned_load128(m0, src);
+      _unaligned_load128(m1, src + 16);
+      vec_st(m0, 0, dst);
+      _unaligned_load128(m2, src + 32);
+      vec_st(m1, 16, dst);
+      _unaligned_load128(m3, src + 48);
+      vec_st(m2, 32, dst);
+      vec_st(m3, 48, dst);
+
+      src += src_stride;
+      dst += dst_stride;
+    }
+  }
+}
diff --git a/vpx_dsp/vpx_dsp.mk b/vpx_dsp/vpx_dsp.mk
index a8cd2645d..05324ee2a 100644
--- a/vpx_dsp/vpx_dsp.mk
+++ b/vpx_dsp/vpx_dsp.mk
@@ -182,6 +182,7 @@ DSP_SRCS-$(HAVE_DSPR2)  += mips/convolve8_horiz_dspr2.c
 DSP_SRCS-$(HAVE_DSPR2)  += mips/convolve8_vert_dspr2.c
 
 DSP_SRCS-$(HAVE_VSX)  += ppc/vpx_convolve_vsx.c
+DSP_SRCS-$(HAVE_ALTIVEC) += ppc/vpx_convolve_altivec.c
 
 # common (lsx)
 DSP_SRCS-$(HAVE_LSX) += loongarch/vpx_convolve8_avg_horiz_lsx.c
@@ -282,6 +283,7 @@ DSP_SRCS-$(HAVE_SSSE3)  += x86/inv_txfm_ssse3.c
 DSP_SRCS-$(HAVE_NEON_ASM) += arm/save_reg_neon$(ASM)
 
 DSP_SRCS-$(HAVE_VSX) += ppc/inv_txfm_vsx.c
+DSP_SRCS-$(HAVE_ALTIVEC) += ppc/vpx_idct_altivec.c
 
 ifneq ($(CONFIG_VP9_HIGHBITDEPTH),yes)
 DSP_SRCS-$(HAVE_MSA)   += mips/inv_txfm_msa.h
diff --git a/vpx_dsp/vpx_dsp_rtcd_defs.pl b/vpx_dsp/vpx_dsp_rtcd_defs.pl
index 9479eb91e..535620d0d 100644
--- a/vpx_dsp/vpx_dsp_rtcd_defs.pl
+++ b/vpx_dsp/vpx_dsp_rtcd_defs.pl
@@ -376,7 +376,7 @@
 # Sub Pixel Filters
 #
 add_proto qw/void vpx_convolve_copy/, "const uint8_t *src, ptrdiff_t src_stride, uint8_t *dst, ptrdiff_t dst_stride, const InterpKernel *filter, int x0_q4, int x_step_q4, int y0_q4, int y_step_q4, int w, int h";
-specialize qw/vpx_convolve_copy neon dspr2 msa sse2 vsx lsx/;
+specialize qw/vpx_convolve_copy altivec neon dspr2 msa sse2 vsx lsx/;
 
 add_proto qw/void vpx_convolve_avg/, "const uint8_t *src, ptrdiff_t src_stride, uint8_t *dst, ptrdiff_t dst_stride, const InterpKernel *filter, int x0_q4, int x_step_q4, int y0_q4, int y_step_q4, int w, int h";
 specialize qw/vpx_convolve_avg neon dspr2 msa sse2 vsx mmi lsx/;
@@ -636,19 +636,19 @@
 if (vpx_config("CONFIG_EMULATE_HARDWARE") ne "yes") {
   # Note that there are more specializations appended when
   # CONFIG_VP9_HIGHBITDEPTH is off.
-  specialize qw/vpx_idct4x4_16_add neon sse2 vsx/;
-  specialize qw/vpx_idct4x4_1_add neon sse2/;
-  specialize qw/vpx_idct8x8_64_add neon sse2 vsx/;
-  specialize qw/vpx_idct8x8_12_add neon sse2 ssse3/;
-  specialize qw/vpx_idct8x8_1_add neon sse2/;
-  specialize qw/vpx_idct16x16_256_add neon sse2 avx2 vsx/;
+  specialize qw/vpx_idct4x4_16_add altivec neon sse2 vsx/;
+  specialize qw/vpx_idct4x4_1_add altivec neon sse2/;
+  specialize qw/vpx_idct8x8_64_add altivec neon sse2 vsx/;
+  specialize qw/vpx_idct8x8_12_add altivec neon sse2 ssse3/;
+  specialize qw/vpx_idct8x8_1_add altivec neon sse2/;
+  specialize qw/vpx_idct16x16_256_add altivec neon sse2 avx2 vsx/;
   specialize qw/vpx_idct16x16_38_add neon sse2/;
-  specialize qw/vpx_idct16x16_10_add neon sse2/;
-  specialize qw/vpx_idct16x16_1_add neon sse2/;
-  specialize qw/vpx_idct32x32_1024_add neon sse2 avx2 vsx/;
+  specialize qw/vpx_idct16x16_10_add altivec neon sse2/;
+  specialize qw/vpx_idct16x16_1_add altivec neon sse2/;
+  specialize qw/vpx_idct32x32_1024_add altivec neon sse2 avx2 vsx/;
   specialize qw/vpx_idct32x32_135_add neon sse2 ssse3 avx2/;
-  specialize qw/vpx_idct32x32_34_add neon sse2 ssse3/;
-  specialize qw/vpx_idct32x32_1_add neon sse2/;
+  specialize qw/vpx_idct32x32_34_add altivec neon sse2 ssse3/;
+  specialize qw/vpx_idct32x32_1_add altivec neon sse2/;
   specialize qw/vpx_iwht4x4_16_add sse2 vsx/;
 
   if (vpx_config("CONFIG_VP9_HIGHBITDEPTH") ne "yes") {
